package com.sa.ibiz.demo.demoapp.controller.demo.vo;

import java.sql.Timestamp;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import lombok.Data;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.demo.domain.UserRoleDatas;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import java.util.Map;
import java.util.Date;
import org.springframework.cglib.beans.BeanCopier;
import javax.validation.constraints.Size;
import java.util.UUID;
import org.springframework.cglib.beans.BeanCopier;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.math.BigInteger;
import com.alibaba.fastjson.JSONObject;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class UserRoleDatas_EditForm_Main{

    @JsonProperty(access=Access.WRITE_ONLY)
    private Map<String,String> srfparentdata;
    @JsonIgnore
    private Timestamp updatedate;
    @JsonProperty(access=Access.WRITE_ONLY)
    private String srforikey;
    @JsonIgnore
    private String userroledatasid;
    @JsonIgnore
    private String userroledatasname;
    @JsonIgnore
    private String srftempmode;
    @JsonProperty
    private String srfuf;
    @JsonProperty
    private String srfdeid;
    @JsonProperty(access=Access.WRITE_ONLY)
    private String srfsourcekey;
    @JsonIgnore
    private String userrolename;
    @JsonIgnore
    private String userroledataname;
    @JsonIgnore
    private String userroledataid;
    @JsonIgnore
    private String userroleid;

    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JsonProperty(value = "srfupdatedate")
    public Timestamp getSrfupdatedate(){
        return updatedate;
    }
    @JsonProperty(value = "srfupdatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    public void setSrfupdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
    }

    @JsonProperty(value = "srforikey")
    public String getSrforikey(){
        return srforikey;
    }
    @JsonProperty(value = "srforikey")
    public void setSrforikey(String srforikey){
        this.srforikey = srforikey;
    }

    @Size(min = 0, max = 100, message = "[用户角色数据能力标识]长度必须在[100]以内!")
    @JsonProperty(value = "srfkey")
    public String getSrfkey(){
        return userroledatasid;
    }
    @JsonProperty(value = "srfkey")
    public void setSrfkey(String userroledatasid){
        this.userroledatasid = userroledatasid;
    }

    @Size(min = 0, max = 200, message = "[用户角色数据能力名称]长度必须在[200]以内!")
    @JsonProperty(value = "srfmajortext")
    public String getSrfmajortext(){
        return userroledatasname;
    }

    @JsonProperty(value = "srftempmode")
    public String getSrftempmode(){
        return srftempmode;
    }
    @JsonProperty(value = "srftempmode")
    public void setSrftempmode(String srftempmode){
        this.srftempmode = srftempmode;
    }

    @JsonProperty(value = "srfdeid")
    public String getSrfdeid(){
        return srfdeid;
    }
    @JsonProperty(value = "srfdeid")
    public void setSrfdeid(String srfdeid){
        this.srfdeid = srfdeid;
    }

    @NotBlank(message = "[用户角色]不允许为空!")
    @Size(min = 0, max = 200, message = "[用户角色]长度必须在[200]以内!")
    @JsonProperty(value = "userrolename")
    public String getUserrolename(){
        return userrolename;
    }
    @JsonProperty(value = "userrolename")
    public void setUserrolename(String userrolename){
        this.userrolename = userrolename;
    }

    @NotBlank(message = "[实体数据能力]不允许为空!")
    @Size(min = 0, max = 200, message = "[实体数据能力]长度必须在[200]以内!")
    @JsonProperty(value = "userroledataname")
    public String getUserroledataname(){
        return userroledataname;
    }
    @JsonProperty(value = "userroledataname")
    public void setUserroledataname(String userroledataname){
        this.userroledataname = userroledataname;
    }

    @Size(min = 0, max = 100, message = "[用户角色数据能力标识]长度必须在[100]以内!")
    @JsonProperty(value = "userroledatasid")
    public String getUserroledatasid(){
        return userroledatasid;
    }
    @JsonProperty(value = "userroledatasid")
    public void setUserroledatasid(String userroledatasid){
        this.userroledatasid = userroledatasid;
    }

    @Size(min = 0, max = 100, message = "[实体数据角色能力]长度必须在[100]以内!")
    @JsonProperty(value = "userroledataid")
    public String getUserroledataid(){
        //输出获取外键值方法-用于通过parentdata关系填充外键值id
        if(StringUtils.isEmpty(userroledataid) && this.getSrfparentdata() != null)
        {
            if(this.getSrfparentdata().containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_USERROLEDATAS_USERROLEDATA_USERROLEDATAID"))
                this.userroledataid=this.getSrfparentdata().get("srfparentkey");
        }
        return userroledataid;
    }
    @JsonProperty(value = "userroledataid")
    public void setUserroledataid(String userroledataid){
        this.userroledataid = userroledataid;
    }

    @Size(min = 0, max = 100, message = "[用户角色]长度必须在[100]以内!")
    @JsonProperty(value = "userroleid")
    public String getUserroleid(){
        //输出获取外键值方法-用于通过parentdata关系填充外键值id
        if(StringUtils.isEmpty(userroleid) && this.getSrfparentdata() != null)
        {
            if(this.getSrfparentdata().containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_USERROLEDATAS_USERROLE_USERROLEID"))
                this.userroleid=this.getSrfparentdata().get("srfparentkey");
        }
        return userroleid;
    }
    @JsonProperty(value = "userroleid")
    public void setUserroleid(String userroleid){
        this.userroleid = userroleid;
    }

    public  void fromUserRoleDatas(UserRoleDatas sourceEntity)  {
        this.fromUserRoleDatas(sourceEntity,true);
    }

     /**
	 * do转换为vo
	 * @param sourceEntity do数据对象
	 * @return
	 */
    public  void fromUserRoleDatas(UserRoleDatas sourceEntity,boolean reset)  {
      BeanCopier copier=BeanCopier.create(UserRoleDatas.class, UserRoleDatas_EditForm_Main.class, false);
      copier.copy(sourceEntity,this,  null);
      this.toString();
	}

    /**
	 * vo转换为do
	 * @param
	 * @return
	 */
    public  UserRoleDatas toUserRoleDatas()  {
        UserRoleDatas targetEntity =new UserRoleDatas();
        BeanCopier copier=BeanCopier.create(UserRoleDatas_EditForm_Main.class, UserRoleDatas.class, false);
        copier.copy(this, targetEntity, null);
        return targetEntity;
	}

     /**
	 * 新建
	 * @param
	 * @return
	 */
    private boolean isCreate()
    {
    	if((StringUtils.isEmpty(this.srfuf))||this.srfuf.equals("0"))
	    	return true;
    	else
    	    return false;
    }
     /**
	 * 更新
	 * @param
	 * @return
	 */
    private boolean isUpdate()
    {
    	if((!StringUtils.isEmpty(this.srfuf))&&this.srfuf.equals("1"))
	    	return true;
    	else
    	    return false;
    }

}
